﻿using SushiBarContracts.BindingModel;
using SushiBarContracts.ViewModels;
using SushiBarDataModels;
using SushiBarDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SushiBarListImplements.Models
{
    public class Shop : IShopModel
    {
        public int Id { get; private set; }
        public string ShopName { get; private set; }
        public string Address { get; private set; }
        public DateTime DateOpening { get; private set; } = DateTime.Now;
        public Dictionary<int, (ISushiModel, int)> ShopSushis
        {
            get;
            private set;
        } = new Dictionary<int, (ISushiModel, int)>();

        public static Shop? Create(ShopBindingModel? model)
        {
            if(model == null) return null;
            return new Shop()
            {
                Id = model.Id,
                ShopName = model.ShopName,
                Address = model.Address,
                DateOpening = model.DateOpening,
                ShopSushis = model.ShopSushis
            };
        }

        public void Update(ShopBindingModel? model)
        {
            if (model == null) return;
            ShopName = model.ShopName;
            Address = model.Address;
            DateOpening = model.DateOpening;
            ShopSushis = model.ShopSushis;
        }

        public ShopViewModel GetViewModel => new()
        {
            Id = Id,
            ShopName = ShopName,
            Address = Address,
            DateOpening = DateOpening,
            ShopSushis = ShopSushis
        };
    }
}
